# -*- coding: utf-8 -*-
#
# File: CommitteeMembership.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    StringField(
        name='position',
        widget=StringWidget(
            label='Position',
            label_msgid='FacultyStaffDirectory_label_position',
            i18n_domain='FacultyStaffDirectory',
        )
    ),

    StringField(
        name='title',
        default="Position",
        widget=StringWidget(
            visible={'edit':'invisible', 'view':'visible'},
            label='Title',
            label_msgid='FacultyStaffDirectory_label_title',
            i18n_domain='FacultyStaffDirectory',
        ),
        accessor="Title"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

CommitteeMembership_schema = BaseSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class CommitteeMembership(BaseContent, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Committee Membership Information'

    meta_type = 'CommitteeMembership'
    portal_type = 'CommitteeMembership'
    allowed_content_types = [] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'CommitteeMembership.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Committee Membership Information"
    typeDescMsgId = 'description_edit_committeemembership'


    actions =  (


       {'action': "string:${object_url}/",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = CommitteeMembership_schema

    ##code-section class-header #fill in your manual code here
    aliases = {
        '(Default)' : '(dynamic view)',
        'view' : '(selected layout)',
        'index.html' : '(dynamic view)',
        'edit' : 'committeemembership_edit',
    }

    ##/code-section class-header

    # Methods


registerType(CommitteeMembership, PROJECTNAME)
# end of class CommitteeMembership

##code-section module-footer #fill in your manual code here
##/code-section module-footer



