# -*- coding: utf-8 -*-
#
# File: Course.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    StringField(
        name='abbreviation',
        widget=StringWidget(
            size="5",
            label='Abbreviation',
            label_msgid='FacultyStaffDirectory_label_abbreviation',
            i18n_domain='FacultyStaffDirectory',
        ),
        searchable=True
    ),

    StringField(
        name='number',
        widget=StringWidget(
            label='Number',
            label_msgid='FacultyStaffDirectory_label_number',
            i18n_domain='FacultyStaffDirectory',
        ),
        searchable=True
    ),

    TextField(
        name='description',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
            label='Description',
            label_msgid='FacultyStaffDirectory_label_description',
            i18n_domain='FacultyStaffDirectory',
        ),
        searchable=True,
        validators=('isTidyHtmlWithCleanup',),
        default_output_type='text/html',
        accessor="Description"
    ),

    StringField(
        name='suffix',
        widget=StringWidget(
            size="1",
            label='Suffix',
            label_msgid='FacultyStaffDirectory_label_suffix',
            i18n_domain='FacultyStaffDirectory',
        )
    ),

    StringField(
        name='website',
        widget=StringWidget(
            label="Course Website",
            description="Example: http://www.example.com/",
            label_msgid='FacultyStaffDirectory_label_website',
            description_msgid='FacultyStaffDirectory_help_website',
            i18n_domain='FacultyStaffDirectory',
        ),
        validators=('isURL',)
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Course_schema = BaseSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Course(BaseContent, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Course'

    meta_type = 'Course'
    portal_type = 'Course'
    allowed_content_types = [] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'Course.gif'
    immediate_view = 'course_view'
    default_view = 'course_view'
    suppl_views = ()
    typeDescription = "A description of a course taught by this person"
    typeDescMsgId = 'description_edit_course'


    actions =  (


       {'action': "string:${object_url}/",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sharing",
        'category': "object",
        'id': 'local_roles',
        'name': 'Sharing',
        'permissions': ("ManageProperties",),
        'condition': 'python:object.portal_membership.checkPermission("ManageProperties", object)'
       },


    )

    _at_rename_after_creation = True

    schema = Course_schema

    ##code-section class-header #fill in your manual code here
    aliases = {
        '(Default)' : 'base_view',
        'view' : 'base_view',
        'index.html' : 'base_view',
        'edit' : 'base_edit',
        'sharing': 'folder_localrole_form'
    }
    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declareProtected(View, 'getRemoteUrl')
    def getRemoteUrl(self):
        return self.website



registerType(Course, PROJECTNAME)
# end of class Course

##code-section module-footer #fill in your manual code here
##/code-section module-footer



