# -*- coding: utf-8 -*-
#
# File: FacultyStaffDirectory.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

FacultyStaffDirectory_schema = OrderedBaseFolderSchema.copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class FacultyStaffDirectory(OrderedBaseFolder, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(OrderedBaseFolder,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Faculty/Staff Directory'

    meta_type = 'FacultyStaffDirectory'
    portal_type = 'FacultyStaffDirectory'
    allowed_content_types = ['Person', 'Classification', 'Document', 'CommitteesFolder', 'SpecialtiesFolder', 'Topic'] + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 1
    #content_icon = 'FacultyStaffDirectory.gif'
    immediate_view = 'directory_standard_view'
    default_view = 'directory_standard_view'
    suppl_views = ('directory_standard_view', 'directory_tabular_view')
    typeDescription = "A directory of faculty and staff members"
    typeDescMsgId = 'description_edit_facultystaffdirectory'


    actions =  (


       {'action': "string:${object_url}/",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sharing",
        'category': "object",
        'id': 'local_roles',
        'name': 'Sharing',
        'permissions': ("ManageProperties",),
        'condition': 'python:object.portal_membership.checkPermission("ManageProperties", object)'
       },


    )

    _at_rename_after_creation = True

    schema = FacultyStaffDirectory_schema

    ##code-section class-header #fill in your manual code here
    # Make this permission show up on every containery object in the Zope instance. This is a Good Thing, because it easy to factor up permissions. The Zope Developer's Guide says to put this here, not in the install procedure (http://www.zope.org/Documentation/Books/ZDG/current/Security.stx). This is because it isn't "sticky", in the sense of being persisted through the ZODB. Thus, it has to run every time Zope starts up. Thus, when you uninstall the product, the permission doesn't stop showing up, but when you actually remove it from the Products folder, it does.
    security.setPermissionDefault('FacultyStaffDirectory: Add or Remove People', ['Manager', 'Owner'])

    # Rig it so the selected view actually takes effect:
    aliases = {
        '(Default)': '(dynamic view)',
        'view': '(selected layout)',
        'index.html': '(dynamic view)',
        'edit': 'base_edit',
        'sharing': 'folder_localrole_form'
    }

    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declarePublic('IFacultyStaffDirectoryAddable')
    def IFacultyStaffDirectoryAddable(self):
        """
        """
        pass
    security.declarePrivate('at_post_create_script')
    def at_post_create_script(self):
        """Actions to perform after a FacultyStaffDirectory is added to a Plone site.
        """
        #Create some default contents
        #No big deal if it doesn't work though, pass exceptions.
        try:
            #Create some base classifications
            self.invokeFactory('Classification', id='faculty', title='Faculty')
            self.invokeFactory('Classification', id='staff', title='Staff')
            self.invokeFactory('Classification', id='grad-students', title='Graduate Students')
            # Create a committees folder
            self.invokeFactory('CommitteesFolder', id='committees', title='Committees')
            # Create a specialties folder
            self.invokeFactory('SpecialtiesFolder', id='specialties', title='Specialties')
        except:
            pass

    security.declareProtected(View, 'getClassifications')
    def getClassifications(self):
        """ return the classifications (in brains form) within this FacultyStaffDirectory """
        return self.getFolderContents({'portal_type':'Classification'})

    security.declareProtected(View, 'getCommitteesFolder')
    def getCommitteesFolder(self):
        """ Return the CommitteesFolder contained in this FacultyStaffDirectory
        """
        return self.getFolderContents({'portal_type':'CommitteesFolder'})[0].getObject()

    security.declareProtected(View, 'getSpecialtiesFolder')
    def getSpecialtiesFolder(self):
        """ Return the specialties folder contained in this FacultyStaffDirectory
        """
        return self.getFolderContents({'portal_type':'SpecialtiesFolder'})[0].getObject()

    security.declareProtected(View, 'getPeople')
    def getPeople(self):
        """ Return a list of people contained within this FacultyStaffDirectory
        """
        return [brain.getObject() for brain in self.getFolderContents({'portal_type':'Person'})]



registerType(FacultyStaffDirectory, PROJECTNAME)
# end of class FacultyStaffDirectory

##code-section module-footer #fill in your manual code here
##/code-section module-footer



