# -*- coding: utf-8 -*-
#
# File: Person.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
import zope
from schema import ExtensibleSchemaSupport
from Products.CMFDynamicViewFTI.browserdefault import BrowserDefaultMixin
from Products.FacultyStaffDirectory.interfaces.person import IPersonContent
from Products.FacultyStaffDirectory.interfaces.person import IPersonModifiedEvent
from Products.Relations.field import RelationField
from Products.FacultyStaffDirectory.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import ReferenceBrowserWidget
from Products.CMFCore.permissions import View, ManageProperties, ModifyPortalContent

##code-section module-header #fill in your manual code here
from zope.interface import implements
from zope.event import notify
from Products.validation import validation
from Products.WebLionLibrary.validators import SequenceValidator
from cStringIO import StringIO
from DateTime import DateTime
from Products.ATContentTypes.lib.calendarsupport import vformat, n2rn, foldLine
from Products.CMFCore.utils import getToolByName

##/code-section module-header

schema = Schema((

    StringField(
        name='firstName',
        widget=StringWidget(
            label="First Name",
            label_msgid='FacultyStaffDirectory_label_firstName',
            i18n_domain='FacultyStaffDirectory',
        ),
        required=True,
        schemata="Basic Information",
        searchable=True
    ),

    StringField(
        name='lastName',
        widget=StringWidget(
            label="Last Name",
            label_msgid='FacultyStaffDirectory_label_lastName',
            i18n_domain='FacultyStaffDirectory',
        ),
        required=True,
        schemata="Basic Information",
        searchable=True
    ),

    StringField(
        name='suffix',
        widget=StringWidget(
            label="Suffix",
            description="Academic, professional, honorary, and social suffixes.",
            label_msgid='FacultyStaffDirectory_label_suffix',
            description_msgid='FacultyStaffDirectory_help_suffix',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Basic Information",
        searchable=True
    ),

    StringField(
        name='email',
        widget=StringWidget(
            label='Email',
            label_msgid='FacultyStaffDirectory_label_email',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Contact Information",
        searchable=True,
        validators=('isEmail',)
    ),

    LinesField(
        name='jobTitles',
        widget=LinesField._properties['widget'](
            label="Job Titles",
            description="One per line",
            label_msgid='FacultyStaffDirectory_label_jobTitles',
            description_msgid='FacultyStaffDirectory_help_jobTitles',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Professional Information",
        searchable=True
    ),

    StringField(
        name='officeAddress',
        widget=TextAreaWidget(
            label="Office Street Address",
            label_msgid='FacultyStaffDirectory_label_officeAddress',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Contact Information",
        searchable=True
    ),

    StringField(
        name='officeCity',
        widget=StringWidget(
            label="Office City",
            label_msgid='FacultyStaffDirectory_label_officeCity',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Contact Information",
        searchable=True
    ),

    StringField(
        name='officeState',
        widget=StringWidget(
            label="Office State",
            label_msgid='FacultyStaffDirectory_label_officeState',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Contact Information"
    ),

    StringField(
        name='officePostalCode',
        widget=StringWidget(
            label="Office Postal Code",
            label_msgid='FacultyStaffDirectory_label_officePostalCode',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Contact Information"
    ),

    StringField(
        name='officePhone',
        widget=StringWidget(
            label="Office Phone",
            description="Example: (555) 555-5555",
            label_msgid='FacultyStaffDirectory_label_officePhone',
            description_msgid='FacultyStaffDirectory_help_officePhone',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Contact Information",
        searchable=True,
        validators=('isUSPhoneNumber',)
    ),

    ImageField(
        name='image',
        schemata="Basic Information",
        widget=ImageWidget(
            label='Image',
            label_msgid='FacultyStaffDirectory_label_image',
            i18n_domain='FacultyStaffDirectory',
        ),
        storage=AttributeStorage(),
        original_size=(400,500),
        sizes={ 'thumb' : (100,125), 'normal' : (200,250)}
    ),

    TextField(
        name='biography',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
            label='Biography',
            label_msgid='FacultyStaffDirectory_label_biography',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Professional Information",
        searchable=True,
        validators=('isTidyHtmlWithCleanup',),
        default_output_type='text/html'
    ),

    LinesField(
        name='education',
        widget=LinesField._properties['widget'](
            label='Education',
            label_msgid='FacultyStaffDirectory_label_education',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Professional Information",
        searchable=True
    ),

    LinesField(
        name='websites',
        widget=LinesField._properties['widget'](
            label="Web Sites",
            description="One per line. Example: http://www.example.com/",
            label_msgid='FacultyStaffDirectory_label_websites',
            description_msgid='FacultyStaffDirectory_help_websites',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Professional Information"
    ),

    StringField(
        name='id',
        widget=StringWidget(
            description="Example: abc123",
            label="Access Account ID",
            label_msgid='FacultyStaffDirectory_label_id',
            description_msgid='FacultyStaffDirectory_help_id',
            i18n_domain='FacultyStaffDirectory',
        ),
        required=1,
        schemata="Basic Information",
        validators=('isValidId', 'isAccessAccountId')
    ),

    ComputedField(
        name='title',
        widget=ComputedField._properties['widget'](
            label="Full Name",
            visible={'edit':'invisible', 'view':'visible'},
            label_msgid='FacultyStaffDirectory_label_title',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Basic Information",
        accessor="Title",
        searchable=True
    ),

    RelationField(
        name='classifications',
        vocabulary="_classificationReferences",
        widget=ReferenceWidget
        (
            label='Classifications',
            label_msgid='FacultyStaffDirectory_label_classifications',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Basic Information",
        multiValued=1,
        relationship='people_classifications'
    ),

    RelationField(
        name='committees',
        widget=ReferenceWidget(
            visible={'edit':'invisible', 'view':'visible'},
            label='Committees',
            label_msgid='FacultyStaffDirectory_label_committees',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Professional Information",
        multiValued=1,
        relationship='members_committees'
    ),

    RelationField(
        name='specialties',
        widget=ReferenceBrowserWidget
        (
            label='Specialties',
            label_msgid='FacultyStaffDirectory_label_specialties',
            i18n_domain='FacultyStaffDirectory',
        ),
        schemata="Professional Information",
        multiValued=True,
        relationship='people_specialties'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Person_schema = OrderedBaseFolderSchema.copy() + \
    getattr(ExtensibleSchemaSupport, 'schema', Schema(())).copy() + \
    getattr(BrowserDefaultMixin, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
class PersonModifiedEvent(object):
    """Event to notify that edits to Person object have been saved.
    """
    implements(IPersonModifiedEvent)

    def __init__(self, context):
        self.context = context


# ArchGenXML won't let us do this:
Person_schema['websites'].validators = SequenceValidator('isURLs', validation.validatorFor('isURL'))
Person_schema['specialties'].allowed_types=('Specialty')
Person_schema['committees'].allowed_types=('Committee')



##/code-section after-schema

class Person(ExtensibleSchemaSupport, OrderedBaseFolder, BrowserDefaultMixin):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(ExtensibleSchemaSupport,'__implements__',()),) + (getattr(OrderedBaseFolder,'__implements__',()),) + (getattr(BrowserDefaultMixin,'__implements__',()),)
    # zope3 interfaces
    zope.interface.implements(IPersonContent)

    # This name appears in the 'add' box
    archetype_name = 'Person'

    meta_type = 'Person'
    portal_type = 'Person'
    allowed_content_types = ['Course', 'BibliographyFolder'] + list(getattr(ExtensibleSchemaSupport, 'allowed_content_types', [])) + list(getattr(BrowserDefaultMixin, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 0
    content_icon = 'user_suit.png'
    immediate_view = 'person_view'
    default_view = 'person_view'
    suppl_views = ()
    typeDescription = "Holds information about a single person"
    typeDescMsgId = 'description_edit_person'


    actions =  (


       {'action': "string:${object_url}/",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/edit",
        'category': "object",
        'id': 'edit',
        'name': 'edit',
        'permissions': ("Modify Portal Content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sharing",
        'category': "object",
        'id': 'local_roles',
        'name': 'Sharing',
        'permissions': ("ManageProperties",),
        'condition': 'python:object.portal_membership.checkPermission("ManageProperties", object)'
       },


       {'action': "string:${object_url}/vcard",
        'category': "document_actions",
        'id': 'vcard',
        'name': 'vCard export',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/image_thumb",
        'category': "object",
        'id': 'kupupreview',
        'name': 'Kupu Preview',
        'permissions': ("View",),
        'condition': 'python:0'
       },


    )

    _at_rename_after_creation = True

    schema = Person_schema

    ##code-section class-header #fill in your manual code here
    # Send 'rename' action to base_edit so we can validate the accessAccountID.
    aliases = {
        '(Default)' : '(dynamic view)',
        'view' : '(selected layout)',
        'index.html' : '(dynamic view)',
        'object_rename' : 'person_edit',
        'edit' : 'pre_edit_setup',
        'vCard' : 'vcard_view',
        'vcard' : 'vcard_view',
        'sharing': 'folder_localrole_form'
    }

    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declareProtected(View, 'at_post_create_script')
    def at_post_create_script(self):
        """Notify that the Person has been modified.
        """
        notify(PersonModifiedEvent(self))

    security.declareProtected(View, 'at_post_edit_script')
    def at_post_edit_script(self):
        """Notify that the Person has been modified.
        """
        notify(PersonModifiedEvent(self))

    def __call__(self, *args, **kwargs):
        return self.getId()

    security.declareProtected(View, 'vcard_view')
    def vcard_view(self, REQUEST, RESPONSE):
        """vCard 3.0 output
        """
        RESPONSE.setHeader('Content-Type', 'text/x-vcard')
        RESPONSE.setHeader('Content-Disposition', 'attachment; filename="%s.vcf"' % self.getId())
        out = StringIO()

        out.write("BEGIN:VCARD\nVERSION:3.0\n")
        out.write("FN:%s\n" % self.Title())
        out.write("N:%s;%s\n" % (self.lastName, self.firstName))
        out.write(foldLine("TITLE:%s\n" % '\\n'.join(self.jobTitles)))
        out.write(foldLine("ADR;TYPE=dom,postal,parcel,work:;;%s;%s;%s;%s\n" % (self.officeAddress.replace('\r\n','\\n'), self.officeCity, self.officeState, self.officePostalCode)))
        out.write("TEL;WORK:%s\n" % self.officePhone)
        out.write("EMAIL;TYPE=internet:%s\n" % self.email)

        #Add the Person page to the list of URLs
        urls = list(self.websites)
        urls.append(self.absolute_url())
        for url in urls:
          out.write(foldLine("URL:%s\n" % url))

        out.write(foldLine("PHOTO;ENCODING=BASE64:%s\n" % self.photo_thumb.data.encode('base-64')))
        out.write("REV:%s\n" % DateTime(self.ModificationDate()).ISO8601())
        out.write("PRODID:WebLion Faculty/Staff Directory\nEND:VCARD")
        return n2rn(out.getvalue())

    security.declareProtected(View, 'getSortableName')
    def getSortableName(self):
        """
        Return a tuple of the person's name. For sorting purposes
        """
        return (self.lastName, self.firstName)

    security.declareProtected(View, 'Title')
    def Title(self):
        """
        Return the Title as firstName lastName, suffix(when available)
        """
        try:
            t = '%s %s' % (self.firstName, self.lastName)  # These don't exist on Person creation.
            if self.suffix:
                t = '%s, %s' % (t, self.suffix)
            return t
        except AttributeError:
            return 'new person'  # YTF doesn't this display on the New Person page?  # Couldn't call superclass's Title() for some unknown reason

    security.declarePrivate('_classificationReferences')
    def _classificationReferences(self):
        """Return a list of Classifications that this Person be can referenced to"""
        return [(c.UID, c.Title) for c in self.aq_parent.getFolderContents({'portal_type':'Classification'})]

    security.declareProtected(View, 'getCourses')
    def getCourses(self):
        """return a listing of Courses within this Person folderish thing"""
        return self.getFolderContents({'portal_type':'Course'})

    security.declareProtected(View, 'getSpecialties')
    def getSpecialties(self):
        """ Get the specialties attached to this person. Returns a list of tuples
            in the format (Specialty object, SpecialtyInformation object)
        """
        refCatalog = getToolByName(self, 'reference_catalog')
        refs = refCatalog.getReferences(self, 'people_specialties')
        if not refs:
            return []
        else:
            return [(ref.getTargetObject(), ref.getContentObject()) for ref in refs]

    security.declareProtected(ModifyPortalContent, 'pre_edit_setup')
    def pre_edit_setup(self):
        """ I hate myself for doing this, but until we can get
            ReferenceBrowserWidget to accept proper relative paths (../../) or
            functions, this is what we get.  Can't do it on __init__ since it
            doesn't recognize any of the portal tools for some reason.
        """
        #Set the startup directory for the members field to the root of the FacultyStaffDirectory
        urlTool = getToolByName(self, 'portal_url')
        self.schema['specialties'].widget.startup_directory = '/%s/' % urlTool.getRelativeContentURL(self.getDirectoryRoot().getSpecialtiesFolder())
        return self.base_edit()



registerType(Person, PROJECTNAME)
# end of class Person

##code-section module-footer #fill in your manual code here
##/code-section module-footer



