# -*- coding: utf-8 -*-
#
# File: testFacultyStaffDirectory.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

##code-section module-header #fill in your manual code here
##/code-section module-header

#
# Test-cases for class(es) 
#

from Testing import ZopeTestCase
from Products.FacultyStaffDirectory.config import *
from Products.FacultyStaffDirectory.tests.testPlone import testPlone

# Import the tested classes
from Products.FacultyStaffDirectory.FacultyStaffDirectory import FacultyStaffDirectory

##code-section module-beforeclass #fill in your manual code here
##/code-section module-beforeclass


class testFacultyStaffDirectory(testPlone):
    """Test-cases for class(es) ."""

    ##code-section class-header_testFacultyStaffDirectory #fill in your manual code here
    ##/code-section class-header_testFacultyStaffDirectory

    def afterSetUp(self):
        self.loginAsPortalOwner()

    # Manually created methods

    def testGetCommitteesFolder(self):
        fsd = self.getPopulatedDirectory()
        committeesFolder = fsd.getCommitteesFolder()
        self.failUnless(committeesFolder.Title() == 'Committees')
        self.failUnless(committeesFolder.Type() == 'Committees Folder')

    def getSpecialtiesFolder(self):
        fsd = self.getPopulatedDirectory()
        specialtiesFolder = fsd.getSpecialtiesFolder()
        self.failUnless(specialtiesFolder.Title() == 'Specialties')
        self.failUnless(specialtiesFolder.Type() == 'Specialties Folder')

    def testDirectoryCreation(self):
        #Make sure the FacultyStaffDirectory was created
        self.portal.invokeFactory(type_name = "FacultyStaffDirectory", id="test_directory")
        self.failUnless('test_directory' in self.portal.contentIds())

    def testDirectory_at_post_create(self):
        #Make sure the autogenerated content is properly created
        fsd = self.getPopulatedDirectory()
        #Check for autogenerated content
        self.failUnless('faculty' in fsd.contentIds())
        self.failUnless('staff' in fsd.contentIds())
        self.failUnless('grad-students' in fsd.contentIds())
        self.failUnless('committees' in fsd.contentIds())
        self.failUnless('specialties' in fsd.contentIds())

    def testGetClassifications(self):
        fsd = self.getPopulatedDirectory()
        classificationsBrains = fsd.getClassifications()
        self.failUnless('faculty' in [c.getObject().id for c in classificationsBrains])


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(testFacultyStaffDirectory))
    return suite

##code-section module-footer #fill in your manual code here
##/code-section module-footer

if __name__ == '__main__':
    framework()


