# -*- coding: utf-8 -*-
#
# File: testPerson.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """WebLion <support@weblion.psu.edu>"""
__docformat__ = 'plaintext'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

##code-section module-header #fill in your manual code here
##/code-section module-header

#
# Test-cases for class(es) Person
#

from Testing import ZopeTestCase
from Products.FacultyStaffDirectory.config import *
from Products.FacultyStaffDirectory.tests.testPlone import testPlone

# Import the tested classes
from Products.FacultyStaffDirectory.Person import Person

##code-section module-beforeclass #fill in your manual code here
##/code-section module-beforeclass


class testPerson(testPlone):
    """Test-cases for class(es) Person."""

    ##code-section class-header_testPerson #fill in your manual code here
    ##/code-section class-header_testPerson

    def afterSetUp(self):
        self.loginAsPortalOwner()
        self.directory = self.getPopulatedDirectory()
        self.person = self.getPerson(id='abc123', firstName="Test", lastName="Person")

    # from class Person:
    def test_view(self):
        pass

    # from class Person:
    def test_edit(self):
        pass

    # from class Person:
    def test_local_roles(self):
        pass

    # from class Person:
    def test_vcard(self):
        pass

    # from class Person:
    def test_kupupreview(self):
        pass

    # Manually created methods

    def testGetDirectoryRoot(self):
        """
        Make sure the getDirectoryRoot script works
        """
        dirRoot = self.person.getDirectoryRoot()
        self.failUnless(dirRoot.Type() == 'Faculty/Staff Directory')

    def testCreatePerson(self):

        #Make sure the Title override is working
        self.failUnless(self.person.Title() == "Test Person")

        #Check the sortable name
        self.failUnless(self.person.getSortableName() == ('Person', 'Test'))

    def testCourses(self):
        """
        Add and retrieve course objects
        """
        self.person.invokeFactory(type_name="Course", id="test-course")
        self.failUnless('test-course' in self.person.contentIds())
        self.failUnless('test-course' in [c.id for c in self.person.getCourses()])

    def testAssignClassifications(self):
        """
        Assign classifications to a person
        """
        classifications = [c.UID for c in self.directory.getClassifications()]
        self.person.setClassifications(classifications)
        for c in self.person.getClassifications():
            self.failUnless(c.id in ['faculty','staff','grad-students'])
            self.failUnless(c.Type() == 'Classification')

    def testSuffix(self):
        #Add a suffix
        self.person.setSuffix('WTF')

        #Title should change
        self.failUnless(self.person.Title() == "Test Person, WTF")

        #But Sortable Name shouldn't
        self.failUnless(self.person.getSortableName() == ('Person', 'Test'))

    def testATReferenceBrowserWidgetHack(self):
        """
        Make sure the workaround for startup_directory works
        """
        #self.person.pre_edit_setup()

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(testPerson))
    return suite

##code-section module-footer #fill in your manual code here
##/code-section module-footer

if __name__ == '__main__':
    framework()


